#!/usr/bin/perl

use strict;
use CGI ;
use CGI::Carp qw(fatalsToBrowser) ;

my $objCgi = CGI->new();

# Checks whether id exists and was delivered via post.
my $strID                  = $objCgi->param("ID");
my $strRequestMethod       = $objCgi->request_method();


if( $strRequestMethod ne "POST"||
    !defined $strID ) {
	print qq~
    <html>
    <head>
    <title>
           WebFlowChart Perl Demo
    </title>
    </head>
    <body>
    <h1>Do not call this page directly</h1>
    </body>
    </html>
	~ ;
	#abort execution
    exit( 0 );
}

# Checks whether id was already setted,
# otherwise set it to unix timestamp.
if( $strID eq "-1" ) {
    $strID = "epf_".time();
}

# Prepares directory for uploaded files.
my $physPath = substr($ENV{"SCRIPT_FILENAME"}, 0, rindex($ENV{"SCRIPT_FILENAME"}, "/") + 1);
my $uploaddir = $physPath."../webflowchart/datastore/";



# Saves epf file.
# Note, that post file-format params are uppercase,
# for exact param declaration, use SDK.

if( defined $objCgi->param("EPF") ) {
    saveFile("EPF", $uploaddir.$strID.'.epf');
}


# Saves png file.
if( defined $objCgi->param("PNG") ) {
    saveFile("PNG", $uploaddir.$strID.'.png');
}

# finally succesful!
print $objCgi->header( -type =>'text/plain' );
print $strID;

#save file in datastore
sub saveFile {
    (my $fileFormat, my $path) = @_;
    open DAT,">".$path ||
    die {
        $objCgi->header( -type =>'text/plain' ),
        "Error:Error occured during ".$fileFormat." save."
    };

    # save file binary
    my $file = $objCgi->param( $fileFormat );
    binmode $file;
    binmode DAT;

    my $data;
    while( read $file,$data,1024 ) {
        print DAT $data;
    }
    close DAT;
}
